Prime Path
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
思路:
在1000到10000的范围内,输入两个数,x,y。 y>x,现在要让你把x变成y。改变x四位数中的任何一位之后如果它为素数,就以他为基准继续变,直到它变成y,也就是以素数为台阶。
这个题感觉还好,一看过去就知道这是用bfs(),因为说的是最短么,所以就用 bfs() 就好了,主要就是这些操作,一个数我们要四次操作。每次操作10个方向,还是很麻烦的。(有的大佬是打表,但是我觉得不打表也成。)
完整代码:
#include<iostream>
#include<cstring>
#include<queue>
#include<cmath>
using namespace std;
int n,x,y;
int Prime[10005];
int t[10005];
void init() //筛选素数,将素数标记
{
Prime[1]=1;
for(int i=2;i<=sqrt(10000);i++)
{
if(Prime[i]==0)
{
for(int j=i+i;j<=10000;j+=i)
{
Prime[j]=1;
}
}
}
}
struct node
{
int w,s; //位,步数
};
void bfs() //搜索
{
node Now,Next;
queue<node>q;
Now.w=x;
Now.s=0;
q.push(Now);
while(!q.empty())
{
Now=q.front();
q.pop();
Next.s=Now.s+1;
if(Now.w==y)
{
cout<<Now.s<<endl;
return ;
}
for(int i=0;i<4;i++)
{
for(int j=0;j<=9;j++)
{
if(i==0)
{
Next.w=Now.w-Now.w%10+j;
}
else if(i==1)
{
Next.w=Now.w+(j-Now.w%100/10)*10;
}
else if(i==2)
{
Next.w=Now.w+(j-Now.w%1000/100)*100;
}
else if(i==3&&j!=0)
{
Next.w=Now.w+(j-Now.w/1000)*1000;
}
if(Prime[Next.w]==0&&t[Next.w]==0)
{
q.push(Next);
t[Next.w]=1;
}
}
}
}
cout<<"Impossible"<<endl;
return ;
}
int main()
{
init();
cin>>n;
while(n--)
{
memset(t,0,sizeof(t));
cin>>x>>y;
if(x==y)
{
cout<<"0"<<endl;
continue;
}
t[x]=1;
bfs();
}
return 0;
}
原题链接:
https://vjudge.net/problem/POJ-3126
http://poj.org/problem?id=3126